//------------------------------------------------------------------------------
//
// Dance Types
//
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using System;
using System.Collections.Generic;
using W3C.Soap;
using dance = ProMRDS.Robotics.Dance;


namespace ProMRDS.Robotics.Dance
{
    
    /// <summary>
    /// Dance Contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// The Dss Service contract
        /// </summary>
        public const String Identifier = "http://www.promrds.com/contracts/2007/10/dance.html";
    }
    /// <summary>
    /// The Dance State
    /// </summary>
    [DataContract()]
    public class DanceState
    {
        [DataMember]
        public int RepeatCount;
        [DataMember]
        public float DriveSpeed;
        [DataMember]
        public float RotateSpeed;
        [DataMember]
        public int DriveTime;
        [DataMember]
        public int RotateTime;
        [DataMember]
        public int SettlingTime;
    }
    /// <summary>
    /// Dance Main Operations Port
    /// </summary>
    [ServicePort()]
    public class DanceOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get>
    {
    }
    /// <summary>
    /// Dance Get Operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<DanceState, Fault>>
    {
        /// <summary>
        /// Dance Get Operation
        /// </summary>
        public Get()
        {
        }
        /// <summary>
        /// Dance Get Operation
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body) : 
                base(body)
        {
        }
        /// <summary>
        /// Dance Get Operation
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body, Microsoft.Ccr.Core.PortSet<DanceState,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
}
