//------------------------------------------------------------------------------
//
// Written Dec-2007 by Trevor Taylor, Software Technology, Australia
//
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using System;
using System.Collections.Generic;
using W3C.Soap;
using ccrexamples = ProMRDS.Robotics.CCRExamples;


namespace ProMRDS.Robotics.CCRExamples
{
    
    /// <summary>
    /// CCRExamples Contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// The Dss Service contract
        /// </summary>
        public const String Identifier = "http://www.promrds.com/contracts/2007/12/ccrexamples.html";
    }
    /// <summary>
    /// The CCRExamples State
    /// </summary>
    [DataContract()]
    public class CCRExamplesState
    {
    }
    /// <summary>
    /// CCRExamples Main Operations Port
    /// </summary>
    [ServicePort()]
    public class CCRExamplesOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get>
    {
    }
    /// <summary>
    /// CCRExamples Get Operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<CCRExamplesState, Fault>>
    {
        /// <summary>
        /// CCRExamples Get Operation
        /// </summary>
        public Get()
        {
        }
        /// <summary>
        /// CCRExamples Get Operation
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body) : 
                base(body)
        {
        }
        /// <summary>
        /// CCRExamples Get Operation
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body, Microsoft.Ccr.Core.PortSet<CCRExamplesState,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
}
