//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.832
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// Generated from:  dssnewservice /s:"SimMagellan" /n:"ProMRDS.Simulation.Magellan" /year:"07" /month:"08"
// </auto-generated>
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Ccr.Adapters.WinForms;
using Microsoft.Dss.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Xml;
using W3C.Soap;
using Microsoft.Robotics.PhysicalModel.Proxy;

using magellan = ProMRDS.Simulation.Magellan;
using drive = Microsoft.Robotics.Services.Drive.Proxy;
using quadDrive = ProMRDS.Simulation.QuadDifferentialDrive.Proxy;
using webcam = Microsoft.Robotics.Services.WebCam.Proxy;
using referee = ProMRDS.Simulation.MagellanReferee.Proxy;
using irsensor = Microsoft.Robotics.Services.AnalogSensor.Proxy;

namespace ProMRDS.Simulation.Magellan
{
    
    /// <summary>
    /// Implementation class for SimMagellan
    /// </summary>
    [DisplayName("SimMagellan")]
    [Description("Orchestration service for simulated SRS Magellan Contest")]
    [Contract(Contract.Identifier)]
    public class SimMagellanService : DsspServiceBase
    {
        SimMagellanUI _magellanUI = null;

        // keep track of which cones have been visited
        List<Waypoint> _waypoints = new List<Waypoint>();
        float _previousHappiness = 0;
        float _previousPreviousHappiness = 0;
        Random _random = new Random();

        // latest image processing result
        ImageProcessResult _imageProcessResult = null;

        // used to communicate with the QuadDifferentialDrive
        [Partner(
            "QuadDrive", 
            Contract = quadDrive.Contract.Identifier, 
            CreationPolicy = PartnerCreationPolicy.UseExisting,
            Optional = false)]
        quadDrive.QuadDriveOperations _quadDrivePort = new quadDrive.QuadDriveOperations();

        // used to communicate with the DifferentialDrive alternate
        [Partner(
            "Drive",
            Contract = drive.Contract.Identifier,
            CreationPolicy = PartnerCreationPolicy.UseExisting,
            Optional = false)]
        drive.DriveOperations _drivePort = new drive.DriveOperations();
        
        // used to communicate with the webcam on the Corobot
        [Partner(
            "robotcam",
            Contract = webcam.Contract.Identifier,
            CreationPolicy = PartnerCreationPolicy.UseExisting,
            Optional = false)]
        webcam.WebCamOperations _cameraPort = new webcam.WebCamOperations();

        // used to communicate with the referee service
        [Partner(
            "referee",
            Contract = referee.Contract.Identifier,
            CreationPolicy = PartnerCreationPolicy.UseExisting,
            Optional = false)]
        referee.MagellanRefereeOperations _refereePort = new referee.MagellanRefereeOperations();
        
        // used to communicate with the IR sensor service
        [Partner(
            "irsensor",
            Contract = irsensor.Contract.Identifier,
            CreationPolicy = PartnerCreationPolicy.UseExisting,
            Optional = false)]
        irsensor.AnalogSensorOperations _irSensorPort = new irsensor.AnalogSensorOperations();
        irsensor.AnalogSensorOperations _irNotifyPort = new irsensor.AnalogSensorOperations();

        // keep track of the time to finish
        DateTime _startTime;
        DateTime _endTime;

        // This port receives events from the user interface
        FromWinformEvents _fromWinformPort = new FromWinformEvents();

        /// <summary>
        /// _state
        /// </summary>
        private SimMagellanState _state = new SimMagellanState();
        /// <summary>
        /// _main Port
        /// </summary>
        [ServicePort("/simmagellan", AllowMultipleInstances=false)]
        private SimMagellanOperations _mainPort = new SimMagellanOperations();
        /// <summary>
        /// Default Service Constructor
        /// </summary>
        public SimMagellanService(DsspServiceCreationPort creationPort) : 
                base(creationPort)
        {
        }
        /// <summary>
        /// Service Start
        /// </summary>
        protected override void Start()
        {
            base.Start();

            // Add the winform message handler to the interleave
            MainPortInterleave.CombineWith(new Interleave(
                new TeardownReceiverGroup(),
                new ExclusiveReceiverGroup
                (
                    Arbiter.Receive<FromWinformMsg>(true, _fromWinformPort, OnWinformMessageHandler)
                ),
                new ConcurrentReceiverGroup()
            ));

            // Create the user interface form
            WinFormsServicePort.Post(new RunForm(CreateForm));

            _state.CurrentMode = ModeType.NotSpecified;

            SpawnIterator(BehaviorLoop);
        }

        // Create the UI form
        System.Windows.Forms.Form CreateForm()
        {
            return new SimMagellanUI(_fromWinformPort);
        }

        // process messages from the UI Form
        void OnWinformMessageHandler(FromWinformMsg msg)
        {
            switch (msg.Command)
            {
                case FromWinformMsg.MsgEnum.Loaded:
                    // the windows form is ready to go
                    _magellanUI = (SimMagellanUI)msg.Object;
                    break;

                case FromWinformMsg.MsgEnum.Reset:
                    _state.CurrentMode = ModeType.Reset;
                    break;

                case FromWinformMsg.MsgEnum.Start:
                    if (_state.CurrentMode == ModeType.Ready)
                    {
                        _startTime = DateTime.Now;
                        _state.CurrentMode = ModeType.Wander;
                    }
                    break;
            }
        }

        /// <summary>
        /// Get Handler
        /// </summary>
        /// <param name="get"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Concurrent)]
        public virtual IEnumerator<ITask> GetHandler(Get get)
        {
            get.ResponsePort.Post(_state);
            yield break;
        }

        const float _rotateSpeed = 0.3f;
        const float _driveSpeed = 0.5f;
        bool _iteratorsStarted = false;

        IEnumerator<ITask> BehaviorLoop()
        {
            bool driveCommandFailed = false;
            ModeType previousMode = ModeType.NotSpecified;
            while (true)
            {
                driveCommandFailed = false;
    
                if (previousMode != _state.CurrentMode)
                {
                    // update the UI
                    WinFormsServicePort.FormInvoke(
                        delegate()
                        {
                            _magellanUI.SetCurrentState(_state.CurrentMode.ToString());
                        }
                    );
                }
                previousMode = _state.CurrentMode;
                switch (_state.CurrentMode)
                {
                    case ModeType.NotSpecified:
                    case ModeType.Ready:
                        yield return Arbiter.Receive(false, TimeoutPort(100), delegate(DateTime timeout) { });
                        break;

                    case ModeType.Reset:
                        {
                            if (!_iteratorsStarted)
                            {
                                // start processing camera frames
                                SpawnIterator<DateTime>(DateTime.Now, ProcessFrame);

                                // start displaying elapsed time
                                SpawnIterator<DateTime>(DateTime.Now, UpdateElapsedTime);

                                _irSensorPort.Subscribe(_irNotifyPort);

                                MainPortInterleave.CombineWith(new Interleave(
                                    new TeardownReceiverGroup(),
                                    new ExclusiveReceiverGroup(),
                                    new ConcurrentReceiverGroup
                                    (
                                        Arbiter.Receive<irsensor.Replace>(true, _irNotifyPort, IRNotifyReplaceHandler)
                                    )
                                ));

                                // we don't want to start additional iterators if the reset button
                                // is pushed to restart the scenario
                                _iteratorsStarted = true;
                            }

                            yield return Arbiter.Choice(_refereePort.Get(),
                                delegate(referee.MagellanRefereeState state) { SetWaypoints(state); },
                                delegate(Fault f) { }
                                );

                            _drivePort.EnableDrive(true);
                            _drivePort.SetDriveSpeed(0, 0);
                            _quadDrivePort.SetPose(new quadDrive.SetPoseRequestType(new Microsoft.Robotics.PhysicalModel.Proxy.Pose()));
                            _state.CurrentMode = ModeType.Ready;

                            break;
                        }
                    case ModeType.Wander:
                        {
                            // check to see if we have identified a cone
                            if (_imageProcessResult != null)
                            {
                                if (_imageProcessResult.Area > _imageProcessResult.AreaThreshold)
                                {
                                    // we have a cone in the crosshairs
                                    _state.CurrentMode = ModeType.Approach;
                                    continue;
                                }
                            }

                            quadDrive.DriveDifferentialFourWheelState quadDriveState = null;
                            yield return Arbiter.Choice(_quadDrivePort.Get(),
                                delegate(quadDrive.DriveDifferentialFourWheelState state)
                                {
                                    quadDriveState = state;
                                },
                                delegate(Fault f) 
                                { 
                                }
                            );

                            if (quadDriveState == null)
                                continue;

                            double distance;
                            double degrees;
                            float currentHappiness = GetHappiness(quadDriveState.Position);
                            if (currentHappiness > _previousHappiness)
                            {
                                // keep going in the same direction
                                distance = 0.25;
                                degrees = 0;
                            }
                            else
                            {
                                // back up and try again
                                if(!driveCommandFailed)
                                    yield return Arbiter.Choice(
                                        _drivePort.DriveDistance(-0.25, _driveSpeed),
                                        delegate(DefaultUpdateResponseType response) { },
                                        delegate(Fault f) { driveCommandFailed = true; }
                                    );
                                
                                distance = 0.25;
                                // choose and angle between -45 and -90.
                                degrees = (float)_random.NextDouble() * -45f - 45f;
                                // restore happiness level of previous position
                                _previousHappiness = _previousPreviousHappiness;
                            }
                            if (degrees != 0)
                            {
                                if (!driveCommandFailed)
                                    yield return Arbiter.Choice(
                                        _drivePort.RotateDegrees(degrees, _rotateSpeed),
                                        delegate(DefaultUpdateResponseType response) { },
                                        delegate(Fault f) { driveCommandFailed = true; }
                                    );
                            }

                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.DriveDistance(distance, _driveSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            _previousPreviousHappiness = _previousHappiness;
                            _previousHappiness = currentHappiness;

                            break;
                        }
                    case ModeType.Approach:
                        {
                            float IRDistance = -1f;

                            // get the IR sensor reading
                            irsensor.Get tmp = new irsensor.Get();
                            _irSensorPort.Post(tmp);
                            yield return Arbiter.Choice(tmp.ResponsePort,
                                delegate(irsensor.AnalogSensorState state)
                                {
                                    if (state.NormalizedMeasurement < 1f)
                                        IRDistance = (float)state.RawMeasurement;
                                },
                                delegate(Fault f) { }
                                );

                            if (IRDistance >= 0)
                            {
                                // rely on the IR sensor for the final approach
                                _state.CurrentMode = ModeType.FinalApproach;
                                break;
                            }

                            if ((_imageProcessResult == null) ||
                                (_imageProcessResult.Area < _imageProcessResult.AreaThreshold))
                            {
                                // lost it, go back to wander mode
                                _state.CurrentMode = ModeType.Wander;
                                continue;
                            }
                            float angle = _imageProcessResult.RightFromCenter * -2f * 5f;
                            float distance = 0.25f;
                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.RotateDegrees(angle, _rotateSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.DriveDistance(distance, _driveSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );
                            break;
                        }
                    case ModeType.FinalApproach:
                        {
                            // rely on the IR sensor for the remainder of the cone approach
                            float IRDistance = -1f;

                            // get the IR sensor reading
                            irsensor.Get tmp = new irsensor.Get();
                            _irSensorPort.Post(tmp);
                            yield return Arbiter.Choice(tmp.ResponsePort,
                                delegate(irsensor.AnalogSensorState state)
                                {
                                    if (state.NormalizedMeasurement < 1f)
                                        IRDistance = (float)state.RawMeasurement;
                                },
                                delegate(Fault f) { }
                                );

                            if (IRDistance < 0)
                            {
                                // go back to the visual approach
                                _state.CurrentMode = ModeType.Approach;
                                break;
                            }
                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.DriveDistance(IRDistance, 0.2),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            // mark the cone as touched
                            quadDrive.DriveDifferentialFourWheelState quadDriveState = null;
                            yield return Arbiter.Choice(_quadDrivePort.Get(),
                                delegate(quadDrive.DriveDifferentialFourWheelState state)
                                {
                                    quadDriveState = state;
                                },
                                delegate(Fault f) { }
                            );

                            if (quadDriveState != null)
                            {
                                for (int i = 0; i < _waypoints.Count; i++)
                                {
                                    float dx = (quadDriveState.Position.X - _waypoints[i].Location.X);
                                    float dz = (quadDriveState.Position.Z - _waypoints[i].Location.Z);
                                    float distance = (float)Math.Sqrt(dx * dx + dz * dz);
                                    if (distance < 1f)
                                        _waypoints[i].Visited = true;
                                }
                            }

                            _state.CurrentMode = ModeType.BackAway;

                            break;
                        }

                    case ModeType.BackAway:
                        {
                            // back away and turn around
                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.DriveDistance(-1, _driveSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.RotateDegrees(45, _rotateSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            _state.CurrentMode = ModeType.Finished;
                            for (int i = 0; i < _waypoints.Count; i++)
                            {
                                if (!_waypoints[i].Visited)
                                {
                                    _state.CurrentMode = ModeType.Wander;
                                    _previousHappiness = 0;
                                    _previousPreviousHappiness = 0;
                                    break;
                                }
                            }

                            if (_state.CurrentMode == ModeType.Finished)
                            {
                                // all the cones have been visited
                                _endTime = DateTime.Now;
                            }

                            break;
                        }

                    case ModeType.AvoidCollision:
                        {
                            // back away
                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.DriveDistance(-0.25, _driveSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            // turn left
                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.RotateDegrees(90, _rotateSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );

                            _state.CurrentMode = ModeType.Wander;

                            // move forward
                            if (!driveCommandFailed)
                                yield return Arbiter.Choice(
                                    _drivePort.DriveDistance(1, _driveSpeed),
                                    delegate(DefaultUpdateResponseType response) { },
                                    delegate(Fault f) { driveCommandFailed = true; }
                                );
                            break;
                        }

                    case ModeType.Finished:
                        if (!driveCommandFailed)
                            yield return Arbiter.Choice(
                                _drivePort.RotateDegrees(180, _rotateSpeed),
                                delegate(DefaultUpdateResponseType response) { },
                                delegate(Fault f) { driveCommandFailed = true; }
                            );
                        break;

                }
            }
        }

        private void SetWaypoints(referee.MagellanRefereeState state)
        {
            foreach (Vector3 location in state.Cones)
                _waypoints.Add(new Waypoint(location));
        }

        private IEnumerator<ITask> UpdateElapsedTime(DateTime timeout)
        {
            string previous = string.Empty;
            while (true)
            {
                string newString = string.Empty;

                switch (_state.CurrentMode)
                {
                    case ModeType.NotSpecified:
                    case ModeType.Ready:
                    case ModeType.Reset:
                        newString = string.Format("Elapsed: {0}:{1:D2}", 0, 0);
                        break;

                    case ModeType.Wander:
                    case ModeType.Approach:
                    case ModeType.FinalApproach:
                    case ModeType.BackAway:
                        {
                            TimeSpan elapsed = DateTime.Now - _startTime;
                            newString = string.Format("Elapsed: {0}:{1:D2}", elapsed.Minutes, elapsed.Seconds);
                            break;
                        }

                    case ModeType.Finished:
                        {
                            TimeSpan elapsed = _endTime - _startTime;
                            newString = string.Format("Elapsed: {0}:{1:D2}", elapsed.Minutes, elapsed.Seconds);
                            break;
                        }
                }

                if (newString != previous)
                {
                    previous = newString;
                    // update the UI
                    WinFormsServicePort.FormInvoke(
                        delegate()
                        {
                            _magellanUI.SetElapsedTime(newString);
                        }
                    );
                }

                yield return Arbiter.Receive(false, TimeoutPort(100), delegate { });
            }
        }

        private IEnumerator<ITask> ProcessFrame(DateTime timeout)
        {
            while (true)
            {

                yield return Arbiter.Choice(
                    _cameraPort.QueryFrame(),
                    ValidateFrameHandler,
                    DefaultFaultHandler);

                yield return Arbiter.Receive(false, TimeoutPort(200), delegate { });
            }
        }

        private void ValidateFrameHandler(webcam.QueryFrameResponse cameraFrame)
        {
            try
            {
                if (cameraFrame.Frame != null)
                {
                    DateTime begin = DateTime.Now;
                    double msFrame = begin.Subtract(cameraFrame.TimeStamp).TotalMilliseconds;

                    // Ignore old images!
                    if (msFrame < 1000.0)
                    {
                        _imageProcessResult = ProcessImage(cameraFrame.Size.Width, cameraFrame.Size.Height, cameraFrame.Frame);
                        double msProcessing = DateTime.Now.Subtract(begin).TotalMilliseconds;
                        LogVerbose(LogGroups.Console, string.Format("{0} Frame {1} ms Processed {2} ms", begin, msFrame, msProcessing));

                        WinFormsServicePort.FormInvoke(
                            delegate()
                            {
                                _magellanUI.SetCameraImage(cameraFrame.Frame, _imageProcessResult);
                            }
                        );
                    }
                    else
                    {
                        LogVerbose(LogGroups.Console, string.Format("Frame discarded {0} ms old", msFrame));
                    }
                }
            }
            catch (Exception ex)
            {
                LogError(ex);
            }
        }

        private ImageProcessResult ProcessImage(int width, int height, byte[] pixels)
        {
            if (pixels == null || width < 1 || height < 1 || pixels.Length < 1)
                return null;

            int offset = 0;
            float threshold = 2.5f;
#if false
            int[] xProjection = new int[width];
            int[] yProjection = new int[height];
#endif
            int xMean = 0;
            int yMean = 0;
            int area = 0;

            // only process every fourth pixel
            for (int y = 0; y < height; y += 2)
            {
                offset = y * width * 3;
                for (int x = 0; x < width; x += 2)
                {
                    int r, g, b;

                    b = pixels[offset++];
                    g = pixels[offset++];
                    r = pixels[offset++];

                    float compare = b * threshold;
                    if((g > compare) && (r > compare))
                    {
                        // color is yellowish
                        xMean += x;
                        yMean += y;
                        area++;

                        // debug coloring
                        pixels[offset - 3] = 255;
                        pixels[offset - 2] = 0;
                        pixels[offset - 1] = 255;
#if false
                        xProjection[x]++;
                        yProjection[y]++;
#endif
                    }
                    offset += 3;    // skip a pixel
                }
            }

            if (area > 0)
            {
                xMean = xMean / area;
                yMean = yMean / area;
                area *= 4;
            }

            ImageProcessResult result = new ImageProcessResult();

            result.XMean = xMean;
            result.YMean = yMean;
            result.Area = area;
            result.RightFromCenter = (float)(xMean - (width / 2)) / (float)width;
            result.DownFromCenter = (float)(yMean - (height / 2)) / (float)height;

#if false
            int xOff = -xMean;
            int xSecond = 0;
            int xThird = 0;

            for (int i = 0; i < xProjection.Length; i++)
            {
                if (xProjection[i] > 0)
                {
                    int square = xOff * xOff * xProjection[i];

                    xSecond += square;
                    xThird += xOff * square;
                }
                xOff++;
            }

            double xStdDev = Math.Sqrt((double)xSecond / area);
            double xSkew = xThird / (area * xStdDev * xStdDev * xStdDev);

            int yOff = -yMean;
            int ySecond = 0;
            int yThird = 0;

            for (int i = 0; i < yProjection.Length; i++)
            {
                if (yProjection[i] > 0)
                {
                    int square = yOff * yOff * yProjection[i];

                    ySecond += square;
                    yThird += yOff * square;
                }
                yOff++;
            }

            double yStdDev = Math.Sqrt((double)ySecond / area);
            double ySkew = yThird / (area * yStdDev * yStdDev * yStdDev);

            result.XStdDev = xStdDev;
            result.YStdDev = yStdDev;
            result.XSkew = xSkew;
            result.YSkew = ySkew;
#endif
            return result;
        }

        /// <summary>
        /// Default Error Handler
        /// </summary>
        /// <param name="fault"></param>
        void DefaultFaultHandler(Fault fault)
        {
            LogError(fault);
        }

        void IRNotifyReplaceHandler(irsensor.Replace replace)
        {
            if (replace.Body.RawMeasurement < 1f)    // closer than 1 meter
            {
                if (_state.CurrentMode == ModeType.Wander)
                {
                    // stop dead in our tracks, abort DriveDistance and RotateDegrees in progress
                    _drivePort.AllStop();
                    _state.CurrentMode = ModeType.AvoidCollision;
                }
            }
        }

        float GetHappiness(Vector3 pos)
        {
            float happiness = 0;
            for(int i=0; i<_waypoints.Count; i++)
            {
                if (_waypoints[i].Visited)
                    continue;

                float dx = (pos.X - _waypoints[i].Location.X);
                float dz = (pos.Z - _waypoints[i].Location.Z);
                float distance = (float)Math.Sqrt(dx * dx + dz * dz);

                float proximity = 50f - Math.Min(distance, 50f);
                if(proximity > 40f)
                    proximity = proximity * proximity;

                happiness += proximity;
            }
            return happiness;
        }
    }

    class Waypoint
    {
        public Vector3 Location;
        public bool Visited;

        public Waypoint(Vector3 location)
        {
            Location = location;
            Visited = false;
        }
    }
}
