@echo off
echo Run TeleOperation
if "%1" == "" goto default
if /I "%1" == "BoeBot" goto boebot
if /I "%1" == "Hemisson" goto hemisson
if /I "%1" == "LegoV2" goto legov2
if /I "%1" == "Stinger" goto stinger
if /I "%1" == "Surveyor" goto surveyor
if /I "%1" == "SRV-1" goto surveyor
if /I "%1" == "Blackfin" goto surveyorb
if /I "%1" == "SRV-1b" goto surveyorb
goto usage

:default
echo Use the Maze Simulator
dsshost32 -p:50000 -t:50001 -m:"%~dp0..\ProMRDS\Config\TeleOperation.manifest.xml" -m:"%~dp0..\ProMRDS\Config\MazeSimulator.manifest.xml"
goto end

:boebot
echo Use a Parallax Boe-Bot
dsshost -port:50000 -tcpport:50001 -manifest:"%~dp0..\ProMRDS\Config\Parallax.BoeBot.manifest.xml" -manifest:"%~dp0..\samples\config\webcam.manifest.xml" -manifest:"%~dp0..\ProMRDS\Config\Teleoperation.manifest.xml"
goto end

:hemisson
dsshost -port:50000 -tcpport:50001 -manifest:"%~dp0..\ProMRDS\Config\Hemisson.manifest.xml" -manifest:"%~dp0..\samples\config\webcam.manifest.xml" -manifest:"%~dp0..\ProMRDS\Config\Teleoperation.manifest.xml"
goto end

:legov2
echo Use a LEGO NXT Tribot with V2 services
dsshost -port:50000 -tcpport:50001 -manifest:"%~dp0..\ProMRDS\Config\MyTribotV2.manifest.xml" -manifest:"%~dp0..\samples\config\webcam.manifest.xml" -manifest:"%~dp0..\ProMRDS\Config\Teleoperation.manifest.xml"
goto end

:stinger
echo Use a Stinger robot
dsshost -port:50000 -tcpport:50001 -manifest:"%~dp0..\ProMRDS\Config\StingerPWMDrive.manifest.xml" -manifest:"%~dp0..\samples\config\webcam.manifest.xml" -manifest:"%~dp0..\ProMRDS\Config\Teleoperation.manifest.xml"
goto end

:surveyor
echo Use a Surveyor SRV-1 robot
dssHost -p:50000 -t:50001 -m:"%~dp0..\samples\config\Surveyor.SRV1.CameraDrive.manifest.xml" -m:"%~dp0..\ProMRDS\Config\TeleOperation.manifest.xml"
goto end

:surveyorb
echo Use a Surveyor SRV-1 Blackfin robot
dssHost -p:50000 -t:50001 -m:"%~dp0..\samples\config\Surveyor.SRV1.Blackfin.CameraDrive.manifest.xml" -m:"%~dp0..\ProMRDS\Config\TeleOperation.manifest.xml"
goto end

:usage
echo Usage: Please enter one of the following commands
echo TeleOperation
echo TeleOperation BoeBot
echo TeleOperation Hemisson
echo TeleOperation LegoV2
echo TeleOperation Stinger
echo TeleOperation Surveyor
echo TeleOperation Blackfin

:end
pause
